<template>
  <div class="full-height flex no-wrap full-width column">
    <div class="q-headline q-px-sm">User/Timing importer</div>
    <div class="flex items-center q-px-sm q-mt-md">
      <div class="text-green q-mr-sm" v-if="fileName">
        {{fileName}}
      </div>
      <q-btn
        :icon="isUsersListUploaded ? 'clear' : 'cloud_upload'"
        :label="isUsersListUploaded ? 'Clear list' : (isUploadingUsersList ? 'Uploading...' : 'Choose users csv file')"
        @click="isUsersListUploaded ? removeList() : uploadList()"
        :color="isUsersListUploaded ? 'red' : 'green'"
        :disable="isUploadingUsersList"
      />
    </div>
    <div class="flex items-center q-px-sm q-mt-md">
      <q-input
        v-if="isUsersListUploaded"
        v-model="timeZone"
        :stack-label="`Timezone${isTimeZoneDetected ? ' (detected)' : ''}`"
        dense
        :disable="isTimeZoneDetected"
        inverted-light
        color="white"
        ref="timezoneField"
      />
      <q-input
        v-if="isUsersListUploaded"
        v-model="date"
        :stack-label="`Event date${isDateDetected ? ' (detected)' : ''}`"
        dense
        :disable="isDateDetected"
        inverted-light
        color="white"
        class="q-ml-sm"
        ref="dateField"
      />
    </div>

    <q-tabs
      v-model="tab"
      inverted
      panes-container-class="col-grow flex column"
      v-if="isUsersListUploaded"
      class="q-mt-md col col-grow q-px-sm"
    >
      <q-tab slot="title" name="compare" label="Comparing table" />
      <q-tab slot="title" name="test" label="Test" />
      <q-tab slot="title" name="runner" label="Runner test" />
      <q-tab slot="title" name="save" label="Save" :disable="!isTested" />

      <q-tab-pane
        class="col-grow flex column q-px-none q-pt-none"
        name="compare"
      >
        <compare-table
          :columns="columns"
          :users="users"
          :timestamp-columns="timestampColumns"
          :timestamp-columns-cameras="timestampColumnsCameras"
          :attached-columns="attachedColumns"
          :default-attached-columns="defaultAttachedColumns"
          :available-columns="availableColumns"
        />
      </q-tab-pane>
      <q-tab-pane
        class="col-grow flex column q-px-none q-pt-none"
        name="test"
      >
        <test-view
          :users="users"
          :attached-columns="attachedColumns"
          :timestamp-columns="timestampColumns"
          :column-cameras="timestampColumnsCameras"
          :time-zone="timeZone"
          :date="date"
          :is-time-zone-detected="isTimeZoneDetected"
        />
      </q-tab-pane>
      <q-tab-pane
        class="col-grow flex column q-px-none q-pt-none"
        name="save"
      >
        <save-timing/>
      </q-tab-pane>
      <q-tab-pane
        class="col-grow flex column q-px-none q-pt-none"
        name="runner"
      >
        <runner-test
          :attached-columns="attachedColumns"
          :user="selectedUser"
          :timestamp-columns="timestampColumns"
          :column-cameras="timestampColumnsCameras"
          :time-zone="timeZone"
          :date="date"
          :is-time-zone-detected="isTimeZoneDetected"
        />
      </q-tab-pane>
    </q-tabs>
  </div>
</template>

<script>
  import moment from 'moment';
  import Inputmask from 'inputmask';
  import csvParser, { concatCSVObject } from '../../utilities/csvParser';
  import CompareTable from './compare-table';
  import TestView from './test-view';
  import {
    DATE_REGEX_DATE, DATE_REGEX_DATETIME, DATE_REGEX_FULL_DATE, DATE_REGEX_TIME,
    DATE_REGEX_TIMESTAMP,
    DATE_REGEX_TIMESTAMP_WITH_MILLISECONDS,
  } from '../../utilities/dateParseRegex';
  import SaveTiming from './save-timing';
  import apiMixin from '../../mixins/apiMixin';
  import RunnerTest from './runner-test';

  export default {
    name: 'user-timing',
    mixins: [apiMixin],
    components: {
      RunnerTest,
      SaveTiming,
      TestView,
      CompareTable,
    },
    data() {
      const timeZone = moment().utcOffset();

      return {
        computedTimings: [],
        computedUsers: [],

        selectedUser: null,

        isTested: false,

        tab: 'compare',

        isUsersListUploaded: false,
        isUploadingUsersList: false,

        fileName: null,

        timeZone: `${ String(Math.floor(timeZone / 60)).padStart(2, '0') }:${ String(Math.floor(timeZone % 60)).padStart(2, '0') }`,
        isTimeZoneDetected: false,
        date: moment().format('YYYY-MM-DD'),
        isDateDetected: false,

        timestampColumnsCameras: {},

        columns: [],
        users: [],

        defaultAttachedColumns: [],
        attachedColumns: {},
        timestampColumns: {},

        availableColumns: [
          'email',
          'name',
          'phone',
          'date_of_birth',
          'gender',
          'concurent_no',
          'race_id',
          'race_name',
          'race_finish_timing',
          'race_finish_place',
          'race_group',
          'race_team',
          'race_start_time',
          'race_finish_time',
          'avg_speed',
          'avg_pace',
          'txt_1',
          'txt_2',
          'txt_3',
          'txt_4',
          'txt_5',
          'txt_6',
          'txt_7',
          'txt_8',
          'txt_9',
          'txt_10',
          'profile',
        ],
      };
    },
    created() {
      this.$eventHub.$on('compareUserClicked', (index) => {
        this.selectedUser = this.users[index];
        this.tab = 'runner';
      });
      this.$eventHub.$on('timingUsersComputed', (users) => {
        this.computedUsers = users;
      });
      this.$eventHub.$on('timingTimingsComputed', (timings) => {
        this.computedTimings = timings;
        this.isTested = true;
      });
      this.$eventHub.$on('timingSchemaChanged', () => {
        this.isTested = false;
      });
      this.$eventHub.$on('saveTimings', this.save);
    },
    methods: {
      save(model) {
        const payload = {
          location_id: this.$store.state.location.location.id,
          ...model,
          user_file: new File([new Blob([concatCSVObject(this.computedUsers)], {
            type: 'text/csv',
          })], 'users_list.csv'),
          timing_file: new File([new Blob([concatCSVObject(this.computedTimings)], {
            type: 'text/csv',
          })], 'timings_list.csv'),
        };

        const data = new FormData();

        Object.entries(payload).forEach(([key, value]) => {
          data.append(key, value);
        });

        this.apiPost(
          'user/importUserInfo',
          data,
          {
            headers: {
              'Content-type': 'multipart/form-data',
            },
          },
          true,
        )
          .then(({
            Status,
            Message,
          }) => {
            if (Status === 'Ok') {
              this.$q.$notify({
                message: 'Users and timings pushed successfully',
                color: 'green',
                actions: [
                  {
                    icon: 'close',
                    'v-close-overlay': true,
                  },
                ],
              });
            } else {
              this.$q.notify({
                message: 'Unable to save users and timings',
                detail: Message,
                actions: [
                  {
                    icon: 'close',
                    'v-close-overlay': true,
                  },
                ],
              });
            }
          })
          .catch();
      },
      parseUsers(csvContent) {
        const {
          columns,
          data,
        } = csvParser(csvContent);

        const attachedColumns = {};
        const defaultAttachedColumns = [];

        columns.forEach((column) => {
          attachedColumns[column] = null;
        });

        this.availableColumns.forEach((column) => {
          if (column in attachedColumns) {
            attachedColumns[column] = column;
            if (this.availableColumns.indexOf(column) > -1) {
              defaultAttachedColumns.push(column);
            }
          }
        });

        this.attachedColumns = attachedColumns;
        this.defaultAttachedColumns = defaultAttachedColumns;

        this.columns = columns;
        this.users = data;

        const timestampColumns = {};
        const timestampColumnsCameras = {};

        this.isTimeZoneDetected = false;
        this.isDateDetected = false;

        Object.entries(this.users[0] || {}).forEach(([key, value]) => {
          const masks = [
            [DATE_REGEX_TIMESTAMP, 'timestamp'],
            [DATE_REGEX_TIMESTAMP_WITH_MILLISECONDS, 'timestampWithMilliseconds'],
            [DATE_REGEX_DATE, 'date'],
            [DATE_REGEX_FULL_DATE, 'fullDate'],
            [DATE_REGEX_DATETIME, 'datetime'],
            [DATE_REGEX_TIME, 'time'],
          ];

          let isValid = false;
          let lastType = null;
          let lastTransformer = null;

          masks.forEach(([mask, type]) => {
            if (!isValid) {
              const matches = String(value).match(mask);
              if (matches) {
                isValid = true;
                lastType = type;
                lastTransformer = (item) => {
                  if (!item) {
                    return false;
                  }
                  const match = item.match(mask);

                  return !!match;
                };
                if (['date', 'fullDate', 'datetime'].indexOf(type) > -1) {
                  if (type === 'fullDate') {
                    if (!this.isTimeZoneDetected) {
                      this.isTimeZoneDetected = true;
                      this.timeZone = type === 'fullDate' ? `${ matches[10][0] === '+' ? matches[10].substr(1) : matches[10] }:${ matches[13] }` : '';
                    }
                  }

                  if (!this.isDateDetected) {
                    if (matches[1]) {
                      this.isDateDetected = true;
                      // eslint-disable-next-line
                      this.date = matches[1];
                    }
                  }
                }
              }
            }
          });

          if (isValid) {
            timestampColumns[key] = [false, lastType, lastTransformer];
            timestampColumnsCameras[key] = [];
          }
        });

        if (!this.isTimeZoneDetected) {
          this.$q.notify({
            message: 'Unable to detect timezone',
            detail: 'Please type it manually',
            actions: [
              {
                icon: 'close',
              },
            ],
          });
        }
        if (!this.isDateDetected) {
          this.$q.notify({
            message: 'Unable to detect date',
            detail: 'Please type it manually',
            actions: [
              {
                icon: 'close',
              },
            ],
          });
        }

        this.$nextTick(() => {
          const { timezoneField, dateField } = this.$refs;

          if (!this.isTimeZoneDetected) {
            Inputmask({
              alias: 'datetime',
              inputFormat: 'hh:MM',
              placeholder: '__:__',
            }).mask(timezoneField.$refs.input);
          }

          if (!this.isDateDetected) {
            Inputmask({
              alias: 'datetime',
              inputFormat: 'yyyy-mm-dd',
              placeholder: '____-__-__',
            }).mask(dateField.$refs.input);
          }

          this.$forceUpdate();
        });

        this.timestampColumnsCameras = timestampColumnsCameras;
        this.timestampColumns = timestampColumns;

        this.isTested = false;
      },
      removeList() {
        this.$q.dialog({
          title: 'Are you sure want to remove current list?',
          color: 'danger',
          ok: true,
          cancel: true,
        })
          .then(() => {
            this.isUsersListUploaded = false;
            this.columns = [];
            this.users = [];
            this.fileName = null;
          });
      },
      uploadList() {
        const fileBrowser = document.createElement('input');
        fileBrowser.type = 'file';
        fileBrowser.accept = 'text/csv';

        const onBodyFocus = () => {
          this.isUploadingUsersList = false;

          document.body.removeEventListener('focus', onBodyFocus);
        };

        fileBrowser.addEventListener('change', () => {
          this.isUploadingUsersList = true;
          if (fileBrowser.files.length) {
            Array.from(fileBrowser.files).forEach((file) => {
              this.isUploadingUsersList = false;
              const reader = new FileReader();
              reader.readAsText(file, 'UTF-8');
              this.fileName = file.name;

              reader.addEventListener('load', (evt) => {
                this.parseUsers(evt.target.result);


                this.isUploadingUsersList = false;
                this.isUsersListUploaded = true;
              });
            });
          } else {
            this.isUploadingUsersList = false;
          }
        });


        fileBrowser.click();
      },
    },
  };
</script>
